<?php

defined('ABSPATH') or exit;

class Montonio_Financing_Iframe
{
    
    const PAYMENT_UPDATE_PATH = '/wc-api/montonio_update';
    
    /**
    * @var string
    */
    protected $paymentCompleteUrl;
    
    /**
    * @var string
    */
    protected $draftToken;
    
    /**
    * @var integer
    */
    protected $orderID;
    
    /**
    * @var boolean
    */
    protected $sandbox;
    
    public static function create() {
        return new self();
    }
    
    public function __construct() {
        
        $this->paymentUpdateUrl = home_url(self::PAYMENT_UPDATE_PATH);
    }
    
    public function setupMontonio() {
        
        // register button for opening Modal
        echo ('<button id="montonio-open-modal">Taotle järelmaksu</button>' );
        
        // Enqueue Montonio SDK and local script 
        wp_enqueue_script(
            'montonio-sdk', 
            'https://public.montonio.com/assets/js/production/montonio-sdk.min.js'
        );
        
        $untranslated = '
        var $env        = "$MONTONIO_ENV"
        var $orderId    = "$MONTONIO_ORDER_ID"
        var $homeUrl    = "$MONTONIO_HOME_URL"
        var $updateUrl  = "$MONTONIO_UPDATE_URL"
        var $draftToken = "$MONTONIO_DRAFT_TOKEN"
        var $ajaxNonce  = "$MONTONIO_AJAX_NONCE"
        ';
        
        // register the variables Montonio needs to open gateway 
        wp_add_inline_script('montonio-sdk', strtr($untranslated, array(
            '$MONTONIO_ENV'         => ($this->getSandbox()) ? "sandbox" : "production",
            '$MONTONIO_ORDER_ID'    => $this->getOrderID(),
            '$MONTONIO_HOME_URL'    => home_url(),
            '$MONTONIO_UPDATE_URL'  => esc_url( $this->paymentUpdateUrl ),
            '$MONTONIO_DRAFT_TOKEN' => $this->getDraftToken(),
            '$MONTONIO_AJAX_NONCE'  => wp_create_nonce('montonio_update_url_return')
            ))
        );
        
        // frontend action script
        wp_enqueue_script(
            'montonio-checkout-order-pay', 
            WCGatewayMontonioPluginUrl. 'assets/js/montonio-checkout-order-pay.js'
        );
        
    }
    
    public function getOrderID() {
        return $this->orderID;
    }
    
    public function setOrderID($orderID) {
        $this->orderID = $orderID;
        return $this;
    }
    
    public function getSandbox() {
        return $this->sandbox;
    }
    
    public function setSandbox($sandbox) {
        $this->sandbox = $sandbox;
        return $this;
    }
    
    public function getDraftToken() {
        return $this->draftToken;
    }
    
    public function setDraftToken($draftToken) {
        $this->draftToken = $draftToken;
        return $this;
    }
}

?>
