<?php

defined('ABSPATH') or exit;

/**
* Static helper validators for controlling hire purchase status and
* detecting fraud
*/
class Montonio_Hirepurchase_Validator 
{
    // MARK: Static helpers
    public static function checkMethod($paymentMethod)
    {
        if ( $paymentMethod != 'montonio') {
            throw new Exception('Something went wrong with the processing of payment.');
        }
    }
    public static function checkCurrency($iso, $id_currency)
    {
        if ( $iso != $id_currency ) {
            throw new Exception('Currencies don\'t match.');
        };
    }
    
    public static function checkId($reference, $orderId)
    {
        if ( (string) $reference !== (string) $orderId ) {
            throw new Exception('Wrong order id passed as reference.');
        }
    }
    
    public static function checkAmount($loanAmount, $totalPaid)
    {
        if ( self::_round($loanAmount) !== self::_round($totalPaid) ) {
            throw new Exception('Loan amounts don\'t match.');
        }
    }
    
    protected static function _round($float)
    {
        return (string) (round($float, 2) * 100);
    }
}